package itemchunkdemo;

import java.sql.*;
import java.util.List;
import org.springframework.batch.core.*;
import org.springframework.batch.core.listener.JobExecutionListenerSupport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.*;

/** Completion-Notification-Listener: ueberprueft das Ergebnis */
public class JobCompletionNotificationListener extends JobExecutionListenerSupport
{
   private final JdbcTemplate jdbcTemplate;

   @Autowired
   public JobCompletionNotificationListener( JdbcTemplate jdbcTemplate )
   {
      this.jdbcTemplate = jdbcTemplate;
   }

   @Override
   public void afterJob( JobExecution jobExecution )
   {
      System.out.println( "---- JobInstance.JobName: " + jobExecution.getJobInstance().getJobName() );
      System.out.println( "     JobExecution.Status: " + jobExecution.getStatus() );
      System.out.println( "     JobParameters:       " + jobExecution.getJobParameters() );
      if( jobExecution.getStatus() == BatchStatus.COMPLETED ) {
         List<Meinedaten> results = jdbcTemplate.query(
                  "Select Vorname, Nachname, Buchstabenanzahl from Meinedaten", new RowMapper<Meinedaten>() {
            @Override
            public Meinedaten mapRow( ResultSet rs, int row ) throws SQLException {
               return new Meinedaten( rs.getString( 1 ), rs.getString( 2 ), Long.valueOf( rs.getLong( 3 ) ) );
            }
         } );
         System.out.println( "---- Datenbankinhalt: " );
         for( Meinedaten md : results ) {
            System.out.println( "     " + md );
         }
      }
   }
}
